#include	"../DLL/d_iNES.h"
#include	"../Hardware/h_MMC3.h"

static	struct
{
	u8 Cmd;
}	Mapper;

static	void	Sync (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0x1F,0);
}

static	int	__cdecl	TileHandler (int Bank, int TileNum, int Index)
{
	if (MMC3_GetCHRBank((Bank ? 4 : 0) | ((TileNum >> 6) & 0x3)) & 0x20)
		MP->Mirror_S1();
	else	MP->Mirror_S0();
	return 1;
}

static	void	__cdecl	SaveMI (Ar128 MI)
{
	MMC3_SaveMI(MI,0);
}

static	void	__cdecl	LoadMI (const Ar128 MI)
{
	MMC3_LoadMI(MI,0);
}

static	void	__cdecl	Write (int Bank, int Where, int What)
{
	MMC3_Write89(Bank,Where,What);
	if (Where & 1)
	{
		if (Mapper.Cmd < 6)
		{
			if (What & 0x20)
				MP->Mirror_S1();
			else	MP->Mirror_S0();
		}
	}
	else	Mapper.Cmd = What & 7;
}

static	void	__cdecl	UnloadMapper (void)
{
	iNES_UnloadROM();
	MMC3_Destroy();
}

static	void	__cdecl	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	iNES_InitROM();

	MP->SetPRG_RAM8(0x6,0);
	MP->Mirror_S0();

	MMC3_Init(Sync);

	MP->SetWriteHandler(0x8,Write);
	MP->SetWriteHandler(0x9,Write);
}

CTMapperInfo	MapperInfo_095 =
{
	"Dragon Buster (MMC3 variant)",
	95,
	MS_Partial,
	8192,
	InitMapper,
	UnloadMapper,
	MMC3_HBlank,
	TileHandler,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};